@import '../base/variables';

// Mixin for Font Properties
@mixin font_property(
  $fontFace,
  $fontSize,
  $fontLineHeight,
  $fontWeight,
  $fontColor
) {
  // Optional Param - Font Family
  @if $fontFace != '' {
    font-family: $fontFace;
  }
  // Optional Param - Font Size
  @if $fontSize != '' {
    font-size: $fontSize;
  }
  // Optional Param - Line Height
  @if $fontLineHeight != '' {
    line-height: $fontLineHeight;
  }
  // Optional Param - Font Weight
  @if $fontWeight != '' {
    font-weight: $fontWeight;
  }
  // Optional Param - Font Color
  @if $fontColor != '' {
    color: $fontColor;
  }
}

// Mixin for Element Positioning
@mixin element_position(
  $positionType,
  $positionTop,
  $positionRight,
  $positionBottom,
  $positionLeft
) {
  // Required Param - Position Type ['absolute', 'relative', 'fixed', 'static', 'sticky']
  position: $positionType;
  // Optional Param - Top
  @if $positionTop != '' {
    top: $positionTop;
  }
  // Optional Param - Right
  @if $positionRight != '' {
    right: $positionRight;
  }
  // Optional Param - Bottom
  @if $positionBottom != '' {
    bottom: $positionBottom;
  }
  // Optional Param - Left
  @if $positionLeft != '' {
    left: $positionLeft;
  }
}

/*
* BEM mixins
*/
@mixin element($el) {
  &__#{$el} {
    @content;
  }
}

@mixin modifier($mod) {
  &--#{$mod} {
    @content;
  }
}

@mixin doubly($margin) {
  & + & {
    margin-left: $margin;
    @content;
  }
}

/*
* Break points - Small to large screens
*/
@mixin break-small-to-large($point, $breakpoints: $breakpoints) {
  @if $point == xMobile {
    @media (min-width: map-get($breakpoints, xMobile)) {
      @content;
    }
  } @else if $point == mobile {
    @media (min-width: map-get($breakpoints, mobile)) {
      @content;
    }
  } @else if $point == xTablet {
    @media (min-width: map-get($breakpoints, xTablet)) {
      @content;
    }
  } @else if $point == tablet {
    @media (min-width: map-get($breakpoints, tablet)) {
      @content;
    }
  } @else if $point == xDesktop {
    @media (min-width: map-get($breakpoints, xDesktop)) {
      @content;
    }
  } @else if $point == desktop {
    @media (min-width: map-get($breakpoints, desktop)) {
      @content;
    }
  }
}

/*
* Break points - Large to small screens
*/
@mixin break-large-to-small($point) {
  @if $point == desktop {
    @media (max-width: map-get($breakpoints, desktop)) {
      @content;
    }
  } @else if $point == xDesktop {
    @media (max-width: map-get($breakpoints, xDesktop)) {
      @content;
    }
  } @else if $point == tablet {
    @media (max-width: map-get($breakpoints, tablet)) {
      @content;
    }
  } @else if $point == xTablet {
    @media (max-width: map-get($breakpoints, xTablet)) {
      @content;
    }
  } @else if $point == mobile {
    @media (max-width: map-get($breakpoints, mobile)) {
      @content;
    }
  } @else if $point == xMobile {
    @media (max-width: map-get($breakpoints, xMobile)) {
      @content;
    }
  }
}

//border animation
@mixin link-animation($thickness: 1px, $bg-color: #f8f9fa) {
  display: inline-block;
  text-decoration: none;
  &::after {
    content: '';
    display: block;
    width: 0;
    height: $thickness;
    background: $bg-color;
    transition: width 0.3s;
  }
  &:hover::after {
    width: 100%;
  }
}

//button animation effects
@mixin button-animation($btn-bg: 'theme-light', $btn-bg-hover: 'semi-dim') {
  vertical-align: middle;
  -webkit-transform: perspective(1px) translateZ(0);
  transform: perspective(1px) translateZ(0);
  box-shadow: 0 0 1px rgba(0, 0, 0, 0);
  position: relative;
  overflow: unset;
  background: map-get($typography-colors, $btn-bg);
  -webkit-transition-property: color;
  transition-property: color;
  -webkit-transition-duration: 0.3s;
  transition-duration: 0.3s;
  display: inline-block;

  &:before {
    content: '';
    position: absolute;
    z-index: -1;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    background: map-get($typography-colors, $btn-bg-hover);
    -webkit-transform: scale(0);
    transform: scale(0);
    -webkit-transition-property: transform;
    transition-property: transform;
    -webkit-transition-duration: 0.3s;
    transition-duration: 0.3s;
    -webkit-transition-timing-function: ease-out;
    transition-timing-function: ease-out;
  }

  &:hover:before {
    transform: scale(1);
  }
}

/*
* Font Smoothing
* @ref-link: https://stackoverflow.com/questions/11487427/is-there-any-font-smoothing-in-google-chrome
* @ref-link: https://developer.mozilla.org/en-US/docs/Web/CSS/font-smooth
*/
@mixin font-smoothing($stroke-width: 0.5px) {
  -webkit-text-stroke-width: $stroke-width;
  -webkit-text-stroke-color: inherit;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
}

/*
* Custom Scrollbar
*/
@mixin custom-scrollbar($thumb: #111012, $track: transparent) {
  &::-webkit-scrollbar {
    width: 6px;
    background-color: transparent;

    &-track {
      -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3);
      border-radius: 0;
      background-color: $track;
    }

    &-thumb {
      border-radius: 0;
      -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3);
      background-color: $thumb;
    }
  }
}

/**
 * Text overflow
 */
@mixin text-overflow($maxWidth) {
  max-width: $maxWidth;
  text-overflow: ellipsis;
  overflow: hidden;
  white-space: nowrap;
}
